--- grx246/pascal/grx.pas.orig	Sun Mar 28 23:15:23 2004
+++ grx246/pascal/grx.pas	Fri Sep 17 19:17:49 2004
@@ -449,71 +454,71 @@
 function  GrBlack:GrColor; asmname 'GrBlack';
 function  GrWhite:GrColor; asmname 'GrWhite';
 
-function  GrBuildRGBcolorT(r,g,b:Integer):GrColor; asmname 'GrBuildRGBcolorT';
-function  GrBuildRGBcolorR(r,g,b:Integer):GrColor; asmname 'GrBuildRGBcolorR';
-function  GrRGBcolorRed(c:GrColor):Integer ; asmname 'GrRGBcolorRed';
-function  GrRGBcolorGreen(c:GrColor):Integer ; asmname 'GrRGBcolorGreen';
-function  GrRGBcolorBlue(c:GrColor):Integer ; asmname 'GrRGBcolorBlue';
+function  GrBuildRGBcolorT(r,g,b:CInteger):GrColor; asmname 'GrBuildRGBcolorT';
+function  GrBuildRGBcolorR(r,g,b:CInteger):GrColor; asmname 'GrBuildRGBcolorR';
+function  GrRGBcolorRed(c:GrColor):CInteger ; asmname 'GrRGBcolorRed';
+function  GrRGBcolorGreen(c:GrColor):CInteger ; asmname 'GrRGBcolorGreen';
+function  GrRGBcolorBlue(c:GrColor):CInteger ; asmname 'GrRGBcolorBlue';
 
-function  GrAllocColor(r,g,b:Integer):GrColor; asmname 'GrAllocColor'; { shared, read-only }
-function  GrAllocColorID(r,g,b:Integer):GrColor; asmname 'GrAllocColorID'; { potentially inlined version }
+function  GrAllocColor(r,g,b:CInteger):GrColor; asmname 'GrAllocColor'; { shared, read-only }
+function  GrAllocColorID(r,g,b:CInteger):GrColor; asmname 'GrAllocColorID'; { potentially inlined version }
 function  GrAllocCell:GrColor; asmname 'GrAllocCell'; { unshared, read-write }
 
 function  GrAllocEgaColors:GrColorsPtr; asmname 'GrAllocEgaColors'; { shared, read-only standard EGA colors }
 
-procedure GrSetColor(c:GrColor; r,g,b:Integer); asmname 'GrSetColor';
+procedure GrSetColor(c:GrColor; r,g,b:CInteger); asmname 'GrSetColor';
 procedure GrFreeColor(c:GrColor); asmname 'GrFreeColor';
 procedure GrFreeCell(c:GrColor);  asmname 'GrFreeCell';
 
-procedure GrQueryColor(c:GrColor; var r,g,b:Integer); asmname 'GrQueryColor';
-procedure GrQueryColorID(c:GrColor; var r,g,b:Integer); asmname 'GrQueryColorID';
+procedure GrQueryColor(c:GrColor; var r,g,b:CInteger); asmname 'GrQueryColor';
+procedure GrQueryColorID(c:GrColor; var r,g,b:CInteger); asmname 'GrQueryColorID';
 
-function  GrColorSaveBufferSize:Integer ; asmname 'GrColorSaveBufferSize';
+function  GrColorSaveBufferSize:CInteger ; asmname 'GrColorSaveBufferSize';
 procedure GrSaveColors(Buffer:Pointer); asmname 'GrSaveColors';
 procedure GrRestoreColors(Buffer:Pointer); asmname 'GrRestoreColors';
 
 type
-  { typedef struct } { framed box colors }
+  { framed box colors }
   GrFBoxColors = record
-    fbx_IntColor   : GrColor;
-    fbx_TopColor   : GrColor;
-    fbx_RightColor : GrColor;
-    fbx_BottomColor: GrColor;
-    fbx_LeftColor  : GrColor;
+    fbx_IntColor,
+    fbx_TopColor,
+    fbx_RightColor,
+    fbx_BottomColor,
+    fbx_LeftColor: GrColor
   end;
 
 procedure GrClearScreen(bg:GrColor); asmname 'GrClearScreen';
 procedure GrClearClipBox(bg:GrColor); asmname 'GrClearClipBox';
-procedure GrPlot(x, y: Integer; c:GrColor); asmname 'GrPlot';
-procedure GrLine(x1, y1, x2, y2: Integer; c:GrColor); asmname 'GrLine';
-procedure GrHLine(x1, x2, y:Integer; c:GrColor); asmname 'GrHLine';
-procedure GrVLine(x, y1, y2: Integer; c: GrColor); asmname 'GrVLine';
-procedure GrBox(x1, y1, x2, y2: Integer; c: GrColor); asmname 'GrBox';
-procedure GrFilledBox(x1, y1, x2, y2: Integer; c: GrColor); asmname 'GrFilledBox';
-procedure GrFramedBox(x1, y1, x2, y2, Wdt: Integer; protected var c: GrFBoxColors); asmname 'GrFramedBox';
-function  GrGenerateEllipse(xc, yc, xa, ya:Integer; var Points{ : array of PointType }):Integer; asmname 'GrGenerateEllipse';
-function  GrGenerateEllipseArc(xc, yc, xa, ya, Start, Ende: Integer; var Points{ : array of PointType }):Integer; asmname 'GrGenerateEllipseArc';
-procedure GrLastArcCoords(var xs, ys, xe, ye, xc, yc: Integer); asmname 'GrLastArcCoords';
-procedure GrCircle(xc, yc, r: Integer; c: GrColor); asmname 'GrCircle';
-procedure GrEllipse(xc, yc, xa, ya: Integer; c: GrColor); asmname 'GrEllipse';
-procedure GrCircleArc(xc, yc, r, Start, Ende, Style: Integer; c: GrColor); asmname 'GrCircleArc';
-procedure GrEllipseArc(xc, yc, xa, ya, Start, Ende, Style: Integer; c: GrColor); asmname 'GrEllipseArc';
-procedure GrFilledCircle(xc, yc, r: Integer; c: GrColor); asmname 'GrFilledCircle';
-procedure GrFilledEllipse(xc, yc, xa, ya: Integer; c: GrColor); asmname 'GrFilledEllipse';
-procedure GrFilledCircleArc(xc, yc, r, Start, Ende, Style: Integer; c: GrColor); asmname 'GrFilledCircleArc';
-procedure GrFilledEllipseArc(xc, yc, xa, ya, Start, Ende, Style: Integer; c: GrColor); asmname 'GrFilledEllipseArc';
-procedure GrPolyLine(NumPts: Integer; var Points{ : array of PointType }; c: GrColor); asmname 'GrPolyLine';
-procedure GrPolygon(NumPts: Integer; var Points{ : array of PointType }; c: GrColor); asmname 'GrPolygon';
-procedure GrFilledConvexPolygon(NumPts: Integer; var Points{ : array of PointType }; c: GrColor); asmname 'GrFilledConvexPolygon';
-procedure GrFilledPolygon(NumPts: Integer; var Points{ : array of PointType }; c: GrColor); asmname 'GrFilledPolygon';
-procedure GrBitBlt(Dest: GrContextPtr; x, y: Integer; Src: GrContextPtr; x1, y1, x2, y2: Integer; Op: GrColor); asmname 'GrBitBlt';
-function  GrPixel(x, y:Integer):GrColor; asmname 'GrPixel';
-function  GrPixelC(c: GrContextPtr; x, y: Integer): GrColor; asmname 'GrPixelC';
+procedure GrPlot(x, y: CInteger; c:GrColor); asmname 'GrPlot';
+procedure GrLine(x1, y1, x2, y2: CInteger; c:GrColor); asmname 'GrLine';
+procedure GrHLine(x1, x2, y:CInteger; c:GrColor); asmname 'GrHLine';
+procedure GrVLine(x, y1, y2: CInteger; c: GrColor); asmname 'GrVLine';
+procedure GrBox(x1, y1, x2, y2: CInteger; c: GrColor); asmname 'GrBox';
+procedure GrFilledBox(x1, y1, x2, y2: CInteger; c: GrColor); asmname 'GrFilledBox';
+procedure GrFramedBox(x1, y1, x2, y2, Wdt: CInteger; protected var c: GrFBoxColors); asmname 'GrFramedBox';
+function  GrGenerateEllipse(xc, yc, xa, ya:CInteger; var Points{ : array of PointType }):CInteger; asmname 'GrGenerateEllipse';
+function  GrGenerateEllipseArc(xc, yc, xa, ya, Start, Ende: CInteger; var Points{ : array of PointType }):CInteger; asmname 'GrGenerateEllipseArc';
+procedure GrLastArcCoords(var xs, ys, xe, ye, xc, yc: CInteger); asmname 'GrLastArcCoords';
+procedure GrCircle(xc, yc, r: CInteger; c: GrColor); asmname 'GrCircle';
+procedure GrEllipse(xc, yc, xa, ya: CInteger; c: GrColor); asmname 'GrEllipse';
+procedure GrCircleArc(xc, yc, r, Start, Ende, Style: CInteger; c: GrColor); asmname 'GrCircleArc';
+procedure GrEllipseArc(xc, yc, xa, ya, Start, Ende, Style: CInteger; c: GrColor); asmname 'GrEllipseArc';
+procedure GrFilledCircle(xc, yc, r: CInteger; c: GrColor); asmname 'GrFilledCircle';
+procedure GrFilledEllipse(xc, yc, xa, ya: CInteger; c: GrColor); asmname 'GrFilledEllipse';
+procedure GrFilledCircleArc(xc, yc, r, Start, Ende, Style: CInteger; c: GrColor); asmname 'GrFilledCircleArc';
+procedure GrFilledEllipseArc(xc, yc, xa, ya, Start, Ende, Style: CInteger; c: GrColor); asmname 'GrFilledEllipseArc';
+procedure GrPolyLine(NumPts: CInteger; var Points{ : array of PointType }; c: GrColor); asmname 'GrPolyLine';
+procedure GrPolygon(NumPts: CInteger; var Points{ : array of PointType }; c: GrColor); asmname 'GrPolygon';
+procedure GrFilledConvexPolygon(NumPts: CInteger; var Points{ : array of PointType }; c: GrColor); asmname 'GrFilledConvexPolygon';
+procedure GrFilledPolygon(NumPts: CInteger; var Points{ : array of PointType }; c: GrColor); asmname 'GrFilledPolygon';
+procedure GrBitBlt(Dest: GrContextPtr; x, y: CInteger; Src: GrContextPtr; x1, y1, x2, y2: CInteger; Op: GrColor); asmname 'GrBitBlt';
+function  GrPixel(x, y:CInteger):GrColor; asmname 'GrPixel';
+function  GrPixelC(c: GrContextPtr; x, y: CInteger): GrColor; asmname 'GrPixelC';
 
-procedure GrFloodFill(x, y: Integer; Border, c: GrColor); asmname 'GrFloodFill';
+procedure GrFloodFill(x, y: CInteger; Border, c: GrColor); asmname 'GrFloodFill';
 
-function GrGetScanline(x1,x2,yy: Integer): GrColorsPtr; asmname 'GrGetScanline';
-function GrGetScanlineC(ctx: GrContextPtr; x1,x2,yy: Integer): GrColorsPtr; asmname 'GrGetScanlineC';
+function GrGetScanline(x1,x2,yy: CInteger): GrColorsPtr; asmname 'GrGetScanline';
+function GrGetScanlineC(ctx: GrContextPtr; x1,x2,yy: CInteger): GrColorsPtr; asmname 'GrGetScanlineC';
 { Input   ctx: source context, if NULL the current context is used }
 {         x1 : first x coordinate read                             }
 {         x2 : last  x coordinate read                             }
@@ -524,7 +529,7 @@
 {                      (w = |x2-y1|)                               }
 {           Output data is valid until next GRX call !             }
 
-procedure GrPutScanline(x1,x2,yy: Integer;c: GrColorsPtr; Op: GrColor); asmname 'GrPutScanline';
+procedure GrPutScanline(x1,x2,yy: CInteger;c: GrColorsPtr; Op: GrColor); asmname 'GrPutScanline';
 { Input   x1: first x coordinate to be set                         }
 {         x2: last  x coordinate to be set                         }
 {         yy: y coordinate                                         }
@@ -540,16 +545,16 @@
         NON CLIPPING DRAWING PRIMITIVES
   ================================================================== }
 
-procedure GrPlotNC(x, y: Integer; c: GrColor); asmname 'GrPlotNC';
-procedure GrLineNC(x1, y1, x2, y2: Integer; c: GrColor); asmname 'GrLineNC';
-procedure GrHLineNC(x1, x2, y: Integer; c: GrColor); asmname 'GrHLineNC';
-procedure GrVLineNC(x, y1, y2: Integer; c: GrColor); asmname 'GrVLineNC';
-procedure GrBoxNC(x1, y1, x2, y2: Integer; c: GrColor); asmname 'GrBoxNC';
-procedure GrFilledBoxNC(x1, y1, x2, y2: Integer; c: GrColor); asmname 'GrFilledBoxNC';
-procedure GrFramedBoxNC(x1, y1, x2, y2, Wdt: Integer; protected var c: GrFBoxColors); asmname 'GrFramedBoxNC';
-procedure GrBitBltNC(Dest: GrContextPtr; x, y: Integer; Src: GrContextPtr; x1, y1, x2, y2: Integer; Op: GrColor); asmname 'GrBitBltNC';
-function  GrPixelNC(x, y:Integer):GrColor; asmname 'GrPixelNC';
-function  GrPixelCNC(c: GrContextPtr; x, y: Integer): GrColor; asmname 'GrPixelCNC';
+procedure GrPlotNC(x, y: CInteger; c: GrColor); asmname 'GrPlotNC';
+procedure GrLineNC(x1, y1, x2, y2: CInteger; c: GrColor); asmname 'GrLineNC';
+procedure GrHLineNC(x1, x2, y: CInteger; c: GrColor); asmname 'GrHLineNC';
+procedure GrVLineNC(x, y1, y2: CInteger; c: GrColor); asmname 'GrVLineNC';
+procedure GrBoxNC(x1, y1, x2, y2: CInteger; c: GrColor); asmname 'GrBoxNC';
+procedure GrFilledBoxNC(x1, y1, x2, y2: CInteger; c: GrColor); asmname 'GrFilledBoxNC';
+procedure GrFramedBoxNC(x1, y1, x2, y2, Wdt: CInteger; protected var c: GrFBoxColors); asmname 'GrFramedBoxNC';
+procedure GrBitBltNC(Dest: GrContextPtr; x, y: CInteger; Src: GrContextPtr; x1, y1, x2, y2: CInteger; Op: GrColor); asmname 'GrBitBltNC';
+function  GrPixelNC(x, y:CInteger):GrColor; asmname 'GrPixelNC';
+function  GrPixelCNC(c: GrContextPtr; x, y: CInteger): GrColor; asmname 'GrPixelCNC';
 
 { ==================================================================
            FONTS AND TEXT PRIMITIVES
@@ -593,41 +598,41 @@
 
 { font structures }
 type
-  { typedef struct _GR_fontHeader }  { font descriptor }
+  { font descriptor }
   GrFontHeader = record
-    Name        : CString;   { font name }
-    Family      : CString;   { font family name }
-    Proportional: ByteBool;  { characters have varying width }
-    Scalable    : ByteBool;  { derived from a scalable font }
-    Preloaded   : ByteBool;  { set when linked Integero program }
-    Modified    : ByteBool;  { "tweaked" font (resized, etc..) }
-    Width       : Cardinal;  { width (proportional=>average) }
-    Height      : Cardinal;  { font height }
-    Baseline    : Cardinal;  { baseline pixel pos (from top) }
-    ULPos       : Cardinal;  { underline pixel pos (from top) }
-    ULHeight    : Cardinal;  { underline width }
-    MinChar     : Cardinal;  { lowest character code in font }
-    NumChars    : Cardinal;  { number of characters in font }
+    Name,                { font name }
+    Family: CString;     { font family name }
+    Proportional,        { characters have varying width }
+    Scalable,            { derived from a scalable font }
+    Preloaded,           { set when linked Integero program }
+    Modified: ByteBool;  { "tweaked" font (resized, etc..) }
+    Width,               { width (proportional=>average) }
+    Height,              { font height }
+    Baseline,            { baseline pixel pos (from top) }
+    ULPos,               { underline pixel pos (from top) }
+    ULHeight,            { underline width }
+    MinChar,             { lowest character code in font }
+    NumChars: CCardinal  { number of characters in font }
   end;
 
-  { typedef struct _GR_fontChrInfo } { character descriptor }
+  { character descriptor }
   GrFontChrInfo = record
-    Width : Cardinal;  { width of this character }
-    Offset: Cardinal;  { offset from start of bitmap }
+    Width,             { width of this character }
+    Offset: CCardinal  { offset from start of bitmap }
   end;
 
-  { typedef struct _GR_font } { the complete font }
-  AuxOffsType = array [0 .. 6] of Integer;
+  { the complete font }
+  AuxOffsType = array [0 .. 6] of CInteger;
   GrFont = record
-    h       : GrFontHeader;  { the font info structure }
-    BitMap  : MemPtr;        { character bitmap array }
-    AuxMap  : MemPtr;        { map for rotated & underline chrs }
-    MinWidth: Cardinal;      { width of narrowest character }
-    MaxWidth: Cardinal;      { width of widest character }
-    AuxSize : Cardinal;      { allocated size of auxiliary map }
-    AuxNext : Cardinal;      { next free byte in auxiliary map }
-    AuxOffs : ^AuxOffsType;  { offsets to completed aux chars }
-    ChrInfo : array [1 .. 1] of GrFontChrInfo;  { character info (not act. size) }
+    h: GrFontHeader;        { the font info structure }
+    BitMap,                 { character bitmap array }
+    AuxMap: MemPtr;         { map for rotated & underline chrs }
+    MinWidth,               { width of narrowest character }
+    MaxWidth,               { width of widest character }
+    AuxSize,                { allocated size of auxiliary map }
+    AuxNext: CCardinal;     { next free byte in auxiliary map }
+    AuxOffs: ^AuxOffsType;  { offsets to completed aux chars }
+    ChrInfo: array [1 .. 1] of GrFontChrInfo  { character info (not act. size) }
   end;
   GrFontPtr = ^GrFont;
 
@@ -639,74 +644,74 @@
   GrDefaultFont: GrFont; varasmname 'GrFont_PC8x14';
 
 function GrLoadFont(FontName: CString): GrFontPtr; asmname 'GrLoadFont';
-function GrLoadConvertedFont(FontName: CString; cvt, w, h, MinCh, MaxCh: Integer): GrFontPtr; asmname 'GrLoadConvertedFont';
-function GrBuildConvertedFont(protected var From: GrFont; cvt, w, h, MinCh, MaxCh: Integer): GrFontPtr; asmname 'GrBuildConvertedFont';
+function GrLoadConvertedFont(FontName: CString; cvt, w, h, MinCh, MaxCh: CInteger): GrFontPtr; asmname 'GrLoadConvertedFont';
+function GrBuildConvertedFont(protected var From: GrFont; cvt, w, h, MinCh, MaxCh: CInteger): GrFontPtr; asmname 'GrBuildConvertedFont';
 
 procedure GrUnloadFont(var Font: GrFont); asmname 'GrUnloadFont';
 procedure GrDumpFont(protected var f: GrFont; CsymbolName, FileName: CString); asmname 'GrDumpFont';
 procedure GrSetFontPath(path_list: CString); asmname 'GrSetFontPath';
 
-function  GrFontCharPresent(protected var Font: GrFont; Chr: Integer): Boolean; asmname 'GrFontCharPresent';
-function  GrFontCharWidth(protected var Font: GrFont; Chr: Integer): Integer; asmname 'GrFontCharWidth';
-function  GrFontCharHeight(protected var Font: GrFont; Chr: Integer): Integer; asmname 'GrFontCharHeight';
-function  GrFontCharBmpRowSize(protected var Font: GrFont; Chr: Integer): Integer; asmname 'GrFontCharBmpRowSize';
-function  GrFontCharBitmapSize(protected var Font: GrFont; Chr: Integer): Integer; asmname 'GrFontCharBitmapSize';
-function  GrFontStringWidth(protected var Font: GrFont; Text: CString; Len, Typ_e: Integer): Integer; asmname 'GrFontStringWidth';
-function  GrFontStringHeight(protected var Font: GrFont; Text: CString; Len, Typ_e: Integer): Integer; asmname 'GrFontStringHeight';
-function  GrProportionalTextWidth(protected var Font: GrFont; Text: CString; Len, Typ_e: Integer): Integer; asmname 'GrProportionalTextWidth';
-function  GrBuildAuxiliaryBitmap(var Font: GrFont; Chr, Dir, ul: Integer): MemPtr; asmname 'GrBuildAuxiliaryBitmap';
-function  GrFontCharBitmap(protected var Font: GrFont; Chr: Integer): MemPtr; asmname 'GrFontCharBitmap';
-function  GrFontCharAuxBmp(var Font: GrFont; Chr, Dir, ul: Integer): MemPtr; asmname 'GrFontCharAuxBmp';
+function  GrFontCharPresent(protected var Font: GrFont; Chr: CInteger): Boolean; asmname 'GrFontCharPresent';
+function  GrFontCharWidth(protected var Font: GrFont; Chr: CInteger): CInteger; asmname 'GrFontCharWidth';
+function  GrFontCharHeight(protected var Font: GrFont; Chr: CInteger): CInteger; asmname 'GrFontCharHeight';
+function  GrFontCharBmpRowSize(protected var Font: GrFont; Chr: CInteger): CInteger; asmname 'GrFontCharBmpRowSize';
+function  GrFontCharBitmapSize(protected var Font: GrFont; Chr: CInteger): CInteger; asmname 'GrFontCharBitmapSize';
+function  GrFontStringWidth(protected var Font: GrFont; Text: CString; Len, Typ_e: CInteger): CInteger; asmname 'GrFontStringWidth';
+function  GrFontStringHeight(protected var Font: GrFont; Text: CString; Len, Typ_e: CInteger): CInteger; asmname 'GrFontStringHeight';
+function  GrProportionalTextWidth(protected var Font: GrFont; Text: CString; Len, Typ_e: CInteger): CInteger; asmname 'GrProportionalTextWidth';
+function  GrBuildAuxiliaryBitmap(var Font: GrFont; Chr, Dir, ul: CInteger): MemPtr; asmname 'GrBuildAuxiliaryBitmap';
+function  GrFontCharBitmap(protected var Font: GrFont; Chr: CInteger): MemPtr; asmname 'GrFontCharBitmap';
+function  GrFontCharAuxBmp(var Font: GrFont; Chr, Dir, ul: CInteger): MemPtr; asmname 'GrFontCharAuxBmp';
 
 type
   GrColorTableP = ^GrColors;
 
-  { typedef union _GR_textColor }   { text color union }
+  { text color union }
   GrTextColor = record
   case 1 .. 2 of
     1: (v: GrColor);           { color value for "direct" text }
     2: (p: GrColorTableP);     { color table for attribute text }
   end;
 
-  { typedef struct _GR_textOption } { text drawing option structure }
+  { text drawing option structure }
   GrTextOption = record
-    txo_Font   : GrFontPtr;    { font to be used }
-    txo_FgColor: GrTextColor;  { foreground color }
+    txo_Font: GrFontPtr;       { font to be used }
+    txo_FgColor,               { foreground color }
     txo_BgColor: GrTextColor;  { background color }
-    txo_ChrType: ByteCard;     { character type (see above) }
-    txo_Direct : ByteCard;     { direction (see above) }
-    txo_XAlign : ByteCard;     { X alignment (see above) }
-    txo_YAlign : ByteCard;     { Y alignment (see above) }
+    txo_ChrType,               { character type (see above) }
+    txo_Direct,                { direction (see above) }
+    txo_XAlign,                { X alignment (see above) }
+    txo_YAlign: ByteCard       { Y alignment (see above) }
   end;
 
-  { typedef struct }        { fixed font text window desc. }
+  { fixed font text window desc. }
   GrTextRegion = record
-    txr_Font      : GrTextColor; { font to be used }
-    txr_FgColor   : GrTextColor; { foreground color }
-    txr_BgColor   : GrTextColor; { background color }
-    txr_Buffer    : Pointer;     { pointer to text buffer }
-    txr_Backup    : Pointer;     { optional backup buffer }
-    txr_Width     : Integer;     { width of area in chars }
-    txr_Height    : Integer;     { height of area in chars }
-    txr_LineOffset: Integer;     { offset in buffer(s) between rows }
-    txr_XPos      : Integer;     { upper left corner X coordinate }
-    txr_YPos      : Integer;     { upper left corner Y coordinate }
-    txr_ChrType   : ByteCard;    { character type (see above) }
-  end;
-
-function  GrCharWidth(Chr: Integer; protected var Opt: GrTextOption): Integer; asmname 'GrCharWidth';
-function  GrCharHeight(Chr: Integer; protected var Opt: GrTextOption): Integer; asmname 'GrCharHeight';
-procedure GrCharSize(Chr: Integer; protected var Opt: GrTextOption; var w, h: Integer); asmname 'GrCharSize';
-function  GrStringWidth(Text: CString; Length: Integer; protected var Opt: GrTextOption): Integer; asmname 'GrStringWidth';
-function  GrStringHeight(Text: CString; Length: Integer; protected var Opt: GrTextOption): Integer; asmname 'GrStringHeight';
-procedure GrStringSize(Text: CString; Length: Integer; protected var Opt: GrTextOption;var w, h: Integer); asmname 'GrStringSize';
-
-procedure GrDrawChar(Chr, x, y: Integer; protected var Opt: GrTextOption); asmname 'GrDrawChar';
-procedure GrDrawString(Text: CString; Length, x, y: Integer; protected var Opt: GrTextOption); asmname 'GrDrawString';
-procedure GrTextXY(x, y: Integer; Text: CString; fg, bg: GrColor); asmname 'GrTextXY';
+    txr_Font: GrFontPtr;       { font to be used }
+    txr_FgColor,               { foreground color }
+    txr_BgColor: GrTextColor;  { background color }
+    txr_Buffer,                { pointer to text buffer }
+    txr_Backup: Pointer;       { optional backup buffer }
+    txr_Width,                 { width of area in chars }
+    txr_Height,                { height of area in chars }
+    txr_LineOffset,            { offset in buffer(s) between rows }
+    txr_XPos,                  { upper left corner X coordinate }
+    txr_YPos: CInteger;        { upper left corner Y coordinate }
+    txr_ChrType: ByteCard      { character type (see above) }
+  end;
+
+function  GrCharWidth(Chr: CInteger; protected var Opt: GrTextOption): CInteger; asmname 'GrCharWidth';
+function  GrCharHeight(Chr: CInteger; protected var Opt: GrTextOption): CInteger; asmname 'GrCharHeight';
+procedure GrCharSize(Chr: CInteger; protected var Opt: GrTextOption; var w, h: CInteger); asmname 'GrCharSize';
+function  GrStringWidth(Text: CString; Length: CInteger; protected var Opt: GrTextOption): CInteger; asmname 'GrStringWidth';
+function  GrStringHeight(Text: CString; Length: CInteger; protected var Opt: GrTextOption): CInteger; asmname 'GrStringHeight';
+procedure GrStringSize(Text: CString; Length: CInteger; protected var Opt: GrTextOption;var w, h: CInteger); asmname 'GrStringSize';
+
+procedure GrDrawChar(Chr, x, y: CInteger; protected var Opt: GrTextOption); asmname 'GrDrawChar';
+procedure GrDrawString(Text: CString; Length, x, y: CInteger; protected var Opt: GrTextOption); asmname 'GrDrawString';
+procedure GrTextXY(x, y: CInteger; Text: CString; fg, bg: GrColor); asmname 'GrTextXY';
 
-procedure GrDumpChar(Chr, Col, Row: Integer; protected var r: GrTextRegion); asmname 'GrDumpChar';
-procedure GrDumpText(Col, Row, Wdt, Hgt: Integer; protected var r: GrTextRegion); asmname 'GrDumpText';
+procedure GrDumpChar(Chr, Col, Row: CInteger; protected var r: GrTextRegion); asmname 'GrDumpChar';
+procedure GrDumpText(Col, Row, Wdt, Hgt: CInteger; protected var r: GrTextRegion); asmname 'GrDumpText';
 procedure GrDumpTextRegion(protected var r: GrTextRegion); asmname 'GrDumpTextRegion';
 
 { =================================================================
@@ -719,20 +724,20 @@
 
 type
   GrLineOption = record
-    No_Color   : GrColor;  { color used to draw line }
-    Lno_Width  : Integer;  { width of the line }
-    Lno_PattLen: Integer;  { length of the dash pattern }
-    Lno_DashPat: MemPtr;   { draw/nodraw pattern }
+    No_Color   : GrColor;   { color used to draw line }
+    Lno_Width,              { width of the line }
+    Lno_PattLen: CInteger;  { length of the dash pattern }
+    Lno_DashPat: MemPtr     { draw/nodraw pattern }
   end;
 
-procedure GrCustomLine(x1, y1, x2, y2: Integer; protected var o: GrLineOption); asmname 'GrCustomLine';
-procedure GrCustomBox(x1, y1, x2, y2: Integer; protected var o: GrLineOption); asmname 'GrCustomBox';
-procedure GrCustomCircle(xc, yc, r: Integer; protected var o: GrLineOption); asmname 'GrCustomCircle';
-procedure GrCustomEllipse(xc, yc, r: Integer; protected var o: GrLineOption); asmname 'GrCustomEllipse';
-procedure GrCustomCircleArc(xc, yc, r, Start, Ende, Style: Integer; protected var o: GrLineOption); asmname 'GrCustomCircleArc';
-procedure GrCustomEllipseArc(xc, yc, xa, ya, Start, Ende, Style: Integer; protected var o: GrLineOption); asmname 'GrCustomEllipseArc';
-procedure GrCustomPolyLine(NumPts: Integer; var Points{ : array of PointType }; protected var o: GrLineOption); asmname 'GrCustomPolyLine';
-procedure GrCustomPolygon(NumPts: Integer; var Points{ : array of PointType }; protected var o: GrLineOption); asmname 'GrCustomPolygon';
+procedure GrCustomLine(x1, y1, x2, y2: CInteger; protected var o: GrLineOption); asmname 'GrCustomLine';
+procedure GrCustomBox(x1, y1, x2, y2: CInteger; protected var o: GrLineOption); asmname 'GrCustomBox';
+procedure GrCustomCircle(xc, yc, r: CInteger; protected var o: GrLineOption); asmname 'GrCustomCircle';
+procedure GrCustomEllipse(xc, yc, r: CInteger; protected var o: GrLineOption); asmname 'GrCustomEllipse';
+procedure GrCustomCircleArc(xc, yc, r, Start, Ende, Style: CInteger; protected var o: GrLineOption); asmname 'GrCustomCircleArc';
+procedure GrCustomEllipseArc(xc, yc, xa, ya, Start, Ende, Style: CInteger; protected var o: GrLineOption); asmname 'GrCustomEllipseArc';
+procedure GrCustomPolyLine(NumPts: CInteger; var Points{ : array of PointType }; protected var o: GrLineOption); asmname 'GrCustomPolyLine';
+procedure GrCustomPolygon(NumPts: CInteger; var Points{ : array of PointType }; protected var o: GrLineOption); asmname 'GrCustomPolygon';
 
 { ==================================================================
            PATTERNED DRAWING AND FILLING PRIMITIVES
@@ -743,14 +748,13 @@
   height is user-defined. SET THE TYPE FLAG TO ZERO!!! }
 
 type
-  { typedef struct _GR_bitmap }
   GrBitmap = record
-    bmp_IsPixMap: Integer;      { type flag for pattern union }
-    bmp_Height  : Integer;      { bitmap height }
-    bmp_Data    : MemPtr;       { pointer to the bit pattern }
-    bmp_FgColor : GrColor;      { foreground color for fill }
-    bmp_BgColor : GrColor;      { background color for fill }
-    bmp_MemFlags: Integer;      { set if dynamically allocated }
+    bmp_IsPixMap,           { type flag for pattern union }
+    bmp_Height: CInteger;   { bitmap height }
+    bmp_Data: MemPtr;       { pointer to the bit pattern }
+    bmp_FgColor,            { foreground color for fill }
+    bmp_BgColor: GrColor;   { background color for fill }
+    bmp_MemFlags: CInteger  { set if dynamically allocated }
   end;
 
   { PIXMAP: a fill pattern stored in a layout identical to the video RAM
@@ -758,21 +762,19 @@
       of the library functions is used to build it. KEEP THE TYPE FLAG
       NONZERO!!! }
 
-  { typedef struct _GR_pixmap }
   GrPixmap = record
-    pxp_IsPixMap: Integer;     { type flag for pattern union }
-    pxp_Width   : Integer;     { pixmap width (in pixels)  }
-    pxp_Height  : Integer;     { pixmap height (in pixels) }
-    pxp_Oper    : GrColor;     { bitblt mode (SET, OR, XOR, AND, IMAGE) }
-    pxp_Source  : GrFrameType; { source context for fill }
+    pxp_IsPixMap,            { type flag for pattern union }
+    pxp_Width,               { pixmap width (in pixels)  }
+    pxp_Height: CInteger;    { pixmap height (in pixels) }
+    pxp_Oper: GrColor;       { bitblt mode (SET, OR, XOR, AND, IMAGE) }
+    pxp_Source: GrFrameType  { source context for fill }
   end;
 
   { Fill pattern union -- can either be a bitmap or a pixmap }
 
-  { typedef union _GR_pattern }
   GrPattern = record
   case 1 .. 3 of
-    1: (gp_IsPixMap: Integer);   { nonzero for pixmaps }
+    1: (gp_IsPixMap: CInteger);   { nonzero for pixmaps }
     2: (gp_BitMap  : GrBitmap);  { fill bitmap }
     3: (gp_PixMap  : GrPixmap);  { fill pixmap }
   end;
